# There is a bootstrap loop between libpysal and networkx when tests/docs are enabled
%bcond_with     bootstrap

# optional has too many requirement, disable it default
%bcond_with     optional

Summary:        Creates and Manipulates Graphs and Networks
Name:           python-networkx
Version:        3.1
Release:        1%{?dist}
License:        BSD-3-Clause
URL:            https://networkx.org/
Source0:        https://github.com/networkx/networkx/archive/networkx-%{version}.tar.gz

Patch3000:      python-networkx-doc.patch

BuildArch:      noarch

BuildRequires:  make
BuildRequires:  python3-devel
BuildRequires:  %{py3_dist setuptools}
BuildRequires:  %{py3_dist pip}
BuildRequires:  %{py3_dist wheel}
%if %{without bootstrap}
BuildRequires:  %{py3_dist numpy}
BuildRequires:  %{py3_dist scipy}

%if %{with optional}
# Extras
BuildRequires:  %{py3_dist pandas}
BuildRequires:  %{py3_dist matplotlib}
BuildRequires:  %{py3_dist lxml}
BuildRequires:  %{py3_dist pygraphviz}
BuildRequires:  %{py3_dist pydot}
BuildRequires:  %{py3_dist sympy}

# Tests
BuildRequires:  %{py3_dist pytest}
BuildRequires:  %{py3_dist pytest-mpl}

%endif
%endif

%description
This package provides Python modules for the creation, manipulation, and
study of the structure, dynamics, and functions of complex networks.

%package -n python3-networkx
Summary:        Creates and Manipulates Graphs and Networks
%if %{with optional}
Recommends:     %{py3_dist lxml}
Recommends:     %{py3_dist pydot}
Recommends:     %{py3_dist pygraphviz}
%endif
Recommends:     xdg-utils

%description -n python3-networkx
This package provides Python 3 modules  for the creation, manipulation, and
study of the structure, dynamics, and functions of complex networks.


%prep
%autosetup -p0 -n networkx-networkx-%{version}


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files networkx
mv %{buildroot}%{_docdir}/networkx-%{version} ./installed-docs
rm -f installed-docs/INSTALL.txt


%check
%if %{with optional} && %{without bootstrap}
%pytest
%endif

%files -n python3-networkx -f %{pyproject_files}
%if %{without bootstrap} && %{with optional}
%doc README.html installed-docs/*
%endif


%changelog
* Tue Sep 26 2023 Shuo Wang <abushwang@tencent.com> - 3.1-1
- update to 3.1

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.8.7-7
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.8.7-6
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.8.7-5
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.8.7-4
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 23 2023 Miaojun Dong <zoedong@tencent.com> - 2.8.7-3
- remove README.md

* Mon Feb 20 2023 cunshunxia <cunshunxia@tencent.com> - 2.8.7-2
- disable optional requirements.

* Thu Nov  3 2022 Yi Lin <nilusyi@tencent.com> - 2.8.7-1
- package init.
